Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/Makefile.deps	(revision 142)
@@ -11,5 +11,5 @@
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 
@@ -21,18 +21,21 @@
 
 Execute_loop_Glue_LIBRARY		= 	-lExecute_loop_Glue	\
-					$(Behavioural_LIBRARY)	
-
-Execute_loop_Glue_DIR_LIBRARY		=	-L$(Execute_loop_Glue_DIR)/lib	\
-					$(Behavioural_DIR_LIBRARY)
+						$(Behavioural_LIBRARY)	
 
 #-----[ Rules ]--------------------------------------------
 
-Execute_loop_Glue_library		:
-				@\
-				$(MAKE) Behavioural_library;		\
-				$(MAKE) --directory=$(Execute_loop_Glue_DIR) --makefile=Makefile;
+Execute_loop_Glue_library_only		:
+					@\
+					$(MAKE) --directory=$(Execute_loop_Glue_DIR) --makefile=Makefile;
 
-Execute_loop_Glue_library_clean	:
-				@\
-				$(MAKE) Behavioural_library_clean;	\
-				$(MAKE) --directory=$(Execute_loop_Glue_DIR) --makefile=Makefile clean;
+Execute_loop_Glue_library_clean_only	:
+					@\
+					$(MAKE) --directory=$(Execute_loop_Glue_DIR) --makefile=Makefile clean;
+
+Execute_loop_Glue_library		: Execute_loop_Glue_library_only
+					@\
+					$(MAKE) Behavioural_library;
+
+Execute_loop_Glue_library_clean		: Execute_loop_Glue_library_clean_only
+					@\
+					$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Makefile.deps	(revision 142)
@@ -55,20 +55,15 @@
 					$(Execution_unit_to_Write_unit_LIBRARY)	
 
-
-Execute_loop_DIR_LIBRARY	=	-L$(Execute_loop_DIR)/lib			\
-					$(Behavioural_DIR_LIBRARY)			\
-					$(Execute_loop_Glue_DIR_LIBRARY)		\
-					$(Read_unit_DIR_LIBRARY)			\
-					$(Functionnal_unit_DIR_LIBRARY)			\
-					$(Load_store_unit_DIR_LIBRARY)			\
-					$(Write_unit_DIR_LIBRARY)			\
-					$(Register_unit_DIR_LIBRARY)			\
-					$(Read_unit_to_Execution_unit_DIR_LIBRARY)	\
-					$(Execution_unit_to_Write_unit_DIR_LIBRARY)	
-
-
 #-----[ Rules ]--------------------------------------------
 
-Execute_loop_library		:
+Execute_loop_library_only	:
+				@\
+				$(MAKE) --directory=$(Execute_loop_DIR) --makefile=Makefile;
+
+Execute_loop_library_clean_only	:
+				@\
+				$(MAKE) --directory=$(Execute_loop_DIR) --makefile=Makefile clean;
+
+Execute_loop_library		: Execute_loop_library_only
 				@\
 				$(MAKE) Behavioural_library;			\
@@ -80,8 +75,7 @@
 				$(MAKE) Register_unit_library;			\
 				$(MAKE) Read_unit_to_Execution_unit_library;	\
-				$(MAKE) Execution_unit_to_Write_unit_library;	\
-				$(MAKE) --directory=$(Execute_loop_DIR) --makefile=Makefile;
+				$(MAKE) Execution_unit_to_Write_unit_library;
 
-Execute_loop_library_clean	:
+Execute_loop_library_clean	: Execute_loop_library_clean_only
 				@\
 				$(MAKE) Behavioural_library_clean;			\
@@ -93,4 +87,3 @@
 				$(MAKE) Register_unit_library_clean;			\
 				$(MAKE) Read_unit_to_Execution_unit_library_clean;	\
-				$(MAKE) Execution_unit_to_Write_unit_library_clean;	\
-				$(MAKE) --directory=$(Execute_loop_DIR) --makefile=Makefile clean;
+				$(MAKE) Execution_unit_to_Write_unit_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Makefile.deps	(revision 142)
@@ -11,43 +11,38 @@
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 ifndef Custom
-include 			$(DIR_MORPHEO)/Behavioural/Custom/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Custom/Makefile.deps
 endif
 ifndef Shifter
-include 			$(DIR_MORPHEO)/Behavioural/Generic/Shifter/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Generic/Shifter/Makefile.deps
 endif
 
 #-----[ Library ]------------------------------------------
-Functionnal_unit_LIBRARY	= 	-lFunctionnal_unit	\
-					$(Custom_LIBRARY)	\
-					-lFunctionnal_unit	\
-					$(Behavioural_LIBRARY)	\
-					-lFunctionnal_unit	\
-					$(Shifter_LIBRARY)	
-
-Functionnal_unit_DIR_LIBRARY	=	-L$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/lib	\
-					$(Custom_DIR_LIBRARY)	   \
-					$(Behavioural_DIR_LIBRARY) \
-					$(Shifter_DIR_LIBRARY)
-
-Functionnal_unit_DEPENDENCIES	=	Custom_library          \
-					Behavioural_library     \
-                                        Shifter_library
-
-Functionnal_unit_CLEAN        	=	Custom_library_clean      \
-					Behavioural_library_clean \
-                                        Shifter_library_clean
+Functionnal_unit_LIBRARY		= 	-lFunctionnal_unit	\
+						$(Custom_LIBRARY)	\
+						$(Behavioural_LIBRARY)	\
+						$(Shifter_LIBRARY)	
 
 #-----[ Rules ]--------------------------------------------
 
-#.NOTPARALLEL			: Functionnal_unit_library Functionnal_unit_library_clean
+Functionnal_unit_library_only		:
+					@\
+					$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit --makefile=Makefile;
 
-Functionnal_unit_library	: $(Functionnal_unit_DEPENDENCIES)
-				@\
-				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit --makefile=Makefile;
+Functionnal_unit_library_clean_only	:
+					@\
+					$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit --makefile=Makefile clean;
 
-Functionnal_unit_library_clean	: $(Functionnal_unit_CLEAN)
-				@\
-				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit --makefile=Makefile clean;
+Functionnal_unit_library		: Functionnal_unit_library_only
+					@\
+					$(MAKE) Custom_library;		\
+					$(MAKE) Behavioural_library;	\
+					$(MAKE) Shifter_library;
+
+Functionnal_unit_library_clean		: Functionnal_unit_library_clean_only
+					@\
+					$(MAKE) Custom_library_clean;		\
+					$(MAKE) Behavioural_library_clean;	\
+					$(MAKE) Shifter_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/Makefile.deps	(revision 142)
@@ -8,23 +8,34 @@
 # DIR_MORPHEO must be defined
 
-Operation		= yes
+Operation			= yes
+
+ifndef Behavioural
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+endif
 
 #-----[ Directory ]----------------------------------------
 
-Operation_DIR           =       $(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation
+Operation_DIR           	=       $(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation
 
 #-----[ Library ]------------------------------------------
 
-Operation_LIBRARY	= 	-lOperation
-
-Operation_DIR_LIBRARY	=	-L$(Operation_DIR)/lib
+Operation_LIBRARY		= 	-lOperation             \
+					$(Behavioural_LIBRARY)
 
 #-----[ Rules ]--------------------------------------------
 
-Operation_library	:
-			@\
-			$(MAKE) --directory=$(Operation_DIR) --makefile=Makefile;
+Operation_library_only		:
+				@\
+				$(MAKE) --directory=$(Operation_DIR) --makefile=Makefile;
 
-Operation_library_clean	:
-			@\
-			$(MAKE) --directory=$(Operation_DIR) --makefile=Makefile clean;
+Operation_library_clean_only	:
+				@\
+				$(MAKE) --directory=$(Operation_DIR) --makefile=Makefile clean;
+
+Operation_library		: Operation_library_only
+				@\
+				$(MAKE) Behavioural_library;
+
+Operation_library_clean		: Operation_library_clean_only
+				@\
+				$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/Makefile.deps	(revision 142)
@@ -8,33 +8,35 @@
 # DIR_MORPHEO must be defined
 
-Load_store_unit			= yes
+Load_store_unit				= yes
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 ifndef Queue_Control
-include 			$(DIR_MORPHEO)/Behavioural/Generic/Queue_Control/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Generic/Queue_Control/Makefile.deps
 endif
 
 #-----[ Library ]------------------------------------------
-Load_store_unit_LIBRARY		= 	-lLoad_store_unit	\
-					$(Queue_Control_LIBRARY)\
-					$(Behavioural_LIBRARY)	
-
-Load_store_unit_DIR_LIBRARY	=	-L$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/lib	\
-					$(Queue_Control_DIR_LIBRARY)\
-					$(Behavioural_DIR_LIBRARY)
+Load_store_unit_LIBRARY			= 	-lLoad_store_unit	\
+						$(Queue_Control_LIBRARY)\
+						$(Behavioural_LIBRARY)	
 
 #-----[ Rules ]--------------------------------------------
 
-Load_store_unit_library		: 
-				@\
-				$(MAKE) Queue_Control_library; \
-				$(MAKE) Behavioural_library; \
-				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit --makefile=Makefile;
+Load_store_unit_library_only		: 
+					@\
+					$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit --makefile=Makefile;
 	
-Load_store_unit_library_clean	: 
-				@\
-				$(MAKE) Queue_Control_library_clean; \
-				$(MAKE) Behavioural_library_clean; \
-				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit --makefile=Makefile clean;
+Load_store_unit_library_clean_only	: 
+					@\
+					$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit --makefile=Makefile clean;
+
+Load_store_unit_library			: Load_store_unit_library_only
+					@\
+					$(MAKE) Queue_Control_library; \
+					$(MAKE) Behavioural_library;
+
+Load_store_unit_library_clean		: Load_store_unit_library_clean_only
+					@\
+					$(MAKE) Queue_Control_library_clean; \
+					$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Makefile.deps	(revision 142)
@@ -25,4 +25,5 @@
 
 #-----[ Library ]------------------------------------------
+
 Read_unit_LIBRARY		= 	-lRead_unit			\
 					$(Behavioural_LIBRARY)		\
@@ -30,27 +31,23 @@
 					$(Reservation_station_LIBRARY)
 
-Read_unit_DIR_LIBRARY		=	-L$(Read_unit_DIR)/lib		\
-					$(Behavioural_DIR_LIBRARY)	\
-					$(Read_queue_DIR_LIBRARY)	\
-					$(Reservation_station_DIR_LIBRARY)
-
-Read_unit_DEPENDENCIES		=	Behavioural_library		\
-					Read_queue_library		\
-					Reservation_station_library
-
-Read_unit_CLEAN	        	=	Behavioural_library_clean	\
-					Read_queue_library_clean	\
-					Reservation_station_library_clean
-
 #-----[ Rules ]--------------------------------------------
 
-.NOTPARALLEL			: Read_unit_library
-.NOTPARALLEL			: Read_unit_library_clean
-
-Read_unit_library		: $(Read_unit_DEPENDENCIES)
+Read_unit_library_only		:
 				@\
 				$(MAKE) --directory=$(Read_unit_DIR) --makefile=Makefile;
 
-Read_unit_library_clean		: $(Read_unit_CLEAN)
+Read_unit_library_clean_only	:
 				@\
 				$(MAKE) --directory=$(Read_unit_DIR) --makefile=Makefile clean;
+
+Read_unit_library		: Read_unit_library_only
+				@\
+				$(MAKE) Behavioural_library;		\
+				$(MAKE) Read_queue_library;		\
+				$(MAKE) Reservation_station_library;
+
+Read_unit_library_clean		: Read_unit_library_clean_only
+				@\
+				$(MAKE) Behavioural_library_clean;		\
+				$(MAKE) Read_queue_library_clean;		\
+				$(MAKE) Reservation_station_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/Makefile.deps	(revision 142)
@@ -18,27 +18,26 @@
 
 #-----[ Library ]------------------------------------------
+
 Read_queue_LIBRARY		= 	-lRead_queue		\
 					$(Queue_LIBRARY)	\
 					$(Behavioural_LIBRARY)	
 
-Read_queue_DIR_LIBRARY		=	-L$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/lib	\
-					$(Queue_DIR_LIBRARY) \
-					$(Behavioural_DIR_LIBRARY)
-
-Read_queue_DEPENDENCIES		=	Queue_library	\
-					Behavioural_library
-
-Read_queue_CLEAN        	=	Queue_library_clean	\
-					Behavioural_library_clean
-
 #-----[ Rules ]--------------------------------------------
 
-#.NOTPARALLEL			: Read_queue_library Read_queue_library_clean
-
-Read_queue_library		: $(Read_queue_DEPENDENCIES)
+Read_queue_library_only		:
 				@\
 				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue --makefile=Makefile;
 
-Read_queue_library_clean	: $(Read_queue_CLEAN)
+Read_queue_library_clean_only	:
 				@\
 				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue --makefile=Makefile clean;
+
+Read_queue_library		: Read_queue_library_only
+				@\
+				$(MAKE) Queue_library;		\
+				$(MAKE) Behavioural_library;
+
+Read_queue_library_clean	: Read_queue_library_clean_only
+				@\
+				$(MAKE) Queue_library_clean;		\
+				$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/Makefile.deps	(revision 142)
@@ -2,5 +2,5 @@
 # $Id$
 # 
-# [ Description ]
+# [ Description ]
 # 
 # Makefile
@@ -8,33 +8,36 @@
 # DIR_MORPHEO must be defined
 
-Reservation_station		= yes
+Reservation_station			= yes
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 ifndef Queue_Control
-include 			$(DIR_MORPHEO)/Behavioural/Generic/Queue_Control/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Generic/Queue_Control/Makefile.deps
 endif
 
-#-----[ Library ]------------------------------------------
-Reservation_station_LIBRARY	= 	-lReservation_station	\
-					$(Queue_Control_LIBRARY)\
-					$(Behavioural_LIBRARY)	
+#-----[ Library ]------------------------------------------
 
-Reservation_station_DIR_LIBRARY	=	-L$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/lib	\
-					$(Queue_Control_DIR_LIBRARY)\
-					$(Behavioural_DIR_LIBRARY)
+Reservation_station_LIBRARY		= 	-lReservation_station	\
+						$(Queue_Control_LIBRARY)\
+						$(Behavioural_LIBRARY)	
 
-#-----[ Rules ]--------------------------------------------
+#-----[ Rules ]--------------------------------------------
 
-Reservation_station_library		: 
-				@\
-				$(MAKE) Queue_Control_library; \
-				$(MAKE) Behavioural_library; \
-				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station --makefile=Makefile;
+Reservation_station_library_only	: 
+					@\
+					$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station --makefile=Makefile;
 	
-Reservation_station_library_clean	: 
-				@\
-				$(MAKE) Queue_Control_library_clean; \
-				$(MAKE) Behavioural_library_clean; \
-				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station --makefile=Makefile clean;
+Reservation_station_library_clean_only	: 
+					@\
+					$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station --makefile=Makefile clean;
+
+Reservation_station_library		: Reservation_station_library_only
+					@\
+					$(MAKE) Queue_Control_library; \
+					$(MAKE) Behavioural_library;
+	
+Reservation_station_library_clean	: Reservation_station_library_clean_only
+					@\
+					$(MAKE) Queue_Control_library_clean; \
+					$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/Makefile.deps	(revision 142)
@@ -22,23 +22,26 @@
 
 #-----[ Library ]------------------------------------------
+
 Execute_queue_LIBRARY		= 	-lExecute_queue	\
 					$(Queue_LIBRARY)	\
 					$(Behavioural_LIBRARY)	
 
-Execute_queue_DIR_LIBRARY	=	-L$(Execute_queue_DIR)/lib	\
-					$(Queue_DIR_LIBRARY) \
-					$(Behavioural_DIR_LIBRARY)
-
 #-----[ Rules ]--------------------------------------------
 
-Execute_queue_library		:
+Execute_queue_library_only	:
+				@\
+				$(MAKE) --directory=$(Execute_queue_DIR) --makefile=Makefile;
+
+Execute_queue_library_clean_only:
+				@\
+				$(MAKE) --directory=$(Execute_queue_DIR) --makefile=Makefile clean;
+
+Execute_queue_library		: Execute_queue_library_only
 				@\
 				$(MAKE) Behavioural_library; \
-				$(MAKE) Queue_library; \
-				$(MAKE) --directory=$(Execute_queue_DIR) --makefile=Makefile;
+				$(MAKE) Queue_library;
 
-Execute_queue_library_clean	:
+Execute_queue_library_clean	: Execute_queue_library_clean_only
 				@\
 				$(MAKE) Behavioural_library_clean; \
-				$(MAKE) Queue_library_clean; \
-				$(MAKE) --directory=$(Execute_queue_DIR) --makefile=Makefile clean;
+				$(MAKE) Queue_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Makefile.deps	(revision 142)
@@ -25,4 +25,5 @@
 
 #-----[ Library ]------------------------------------------
+
 Write_unit_LIBRARY		= 	-lWrite_unit		\
 					$(Behavioural_LIBRARY)	\
@@ -30,22 +31,23 @@
 					$(Execute_queue_LIBRARY)
 
-Write_unit_DIR_LIBRARY		=	-L$(Write_unit_DIR)/lib		\
-					$(Behavioural_DIR_LIBRARY)	\
-					$(Write_queue_DIR_LIBRARY)	\
-					$(Execute_queue_DIR_LIBRARY)
-
 #-----[ Rules ]--------------------------------------------
 
-Write_unit_library		:
+Write_unit_library_only		:
+				@\
+				$(MAKE) --directory=$(Write_unit_DIR) --makefile=Makefile;
+
+Write_unit_library_clean_only	:
+				@\
+				$(MAKE) --directory=$(Write_unit_DIR) --makefile=Makefile clean;
+
+Write_unit_library		: Write_unit_library_only
 				@\
 				$(MAKE) Behavioural_library;		\
 				$(MAKE) Write_queue_library;		\
-				$(MAKE) Execute_queue_library;		\
-				$(MAKE) --directory=$(Write_unit_DIR) --makefile=Makefile;
+				$(MAKE) Execute_queue_library;
 
-Write_unit_library_clean	:
+Write_unit_library_clean	: Write_unit_library_clean_only
 				@\
 				$(MAKE) Behavioural_library_clean;	\
 				$(MAKE) Write_queue_library_clean;	\
-				$(MAKE) Execute_queue_library_clean;	\
-				$(MAKE) --directory=$(Write_unit_DIR) --makefile=Makefile clean;
+				$(MAKE) Execute_queue_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/Makefile.deps	(revision 142)
@@ -27,19 +27,21 @@
 					$(Behavioural_LIBRARY)	
 
-Write_queue_DIR_LIBRARY		=	-L$(Write_queue_DIR)/lib	\
-					$(Queue_DIR_LIBRARY)            \
-					$(Behavioural_DIR_LIBRARY)
-
 #-----[ Rules ]--------------------------------------------
 
-Write_queue_library		:
+Write_queue_library_only	:
+				@\
+				$(MAKE) --directory=$(Write_queue_DIR) --makefile=Makefile;
+
+Write_queue_library_clean_only	:
+				@\
+				$(MAKE) --directory=$(Write_queue_DIR) --makefile=Makefile clean;
+
+Write_queue_library		: Write_queue_library_only
 				@\
 				$(MAKE) Queue_library;	\
-				$(MAKE) Behavioural_library;	\
-				$(MAKE) --directory=$(Write_queue_DIR) --makefile=Makefile;
+				$(MAKE) Behavioural_library;
 
-Write_queue_library_clean	:
+Write_queue_library_clean	: Write_queue_library_clean_only
 				@\
 				$(MAKE) Queue_library_clean;	\
-				$(MAKE) Behavioural_library_clean;	\
-				$(MAKE) --directory=$(Write_queue_DIR) --makefile=Makefile clean;
+				$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/Makefile.deps	(revision 142)
@@ -11,27 +11,31 @@
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 					$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 
 #-----[ Directory ]----------------------------------------
 
-Execution_unit_to_Write_unit_DIR			=	$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit
+Execution_unit_to_Write_unit_DIR		=	$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit
 
 #-----[ Library ]------------------------------------------
+
 Execution_unit_to_Write_unit_LIBRARY		= 	-lExecution_unit_to_Write_unit	\
-					$(Behavioural_LIBRARY)	
-
-Execution_unit_to_Write_unit_DIR_LIBRARY		=	-L$(Execution_unit_to_Write_unit_DIR)/lib	\
-					$(Behavioural_DIR_LIBRARY)
+							$(Behavioural_LIBRARY)	
 
 #-----[ Rules ]--------------------------------------------
 
-Execution_unit_to_Write_unit_library		:
-				@\
-				$(MAKE) --directory=$(Behavioural_DIR) --makefile=Makefile;
-				$(MAKE) --directory=$(Execution_unit_to_Write_unit_DIR) --makefile=Makefile;
+Execution_unit_to_Write_unit_library_only	:
+						@\
+						$(MAKE) --directory=$(Execution_unit_to_Write_unit_DIR) --makefile=Makefile;
 
-Execution_unit_to_Write_unit_library_clean	:
-				@\
-				$(MAKE) --directory=$(Behavioural_DIR) --makefile=Makefile clean;
-				$(MAKE) --directory=$(Execution_unit_to_Write_unit_DIR) --makefile=Makefile clean;
+Execution_unit_to_Write_unit_library_clean_only	:
+						@\
+						$(MAKE) --directory=$(Execution_unit_to_Write_unit_DIR) --makefile=Makefile clean;
+
+Execution_unit_to_Write_unit_library		: Execution_unit_to_Write_unit_library_only
+						@\
+						$(MAKE) Behavioural_library;
+
+Execution_unit_to_Write_unit_library_clean	: Execution_unit_to_Write_unit_library_clean_only
+						@\
+						$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/Makefile.deps	(revision 142)
@@ -19,19 +19,23 @@
 
 #-----[ Library ]------------------------------------------
+
 Read_unit_to_Execution_unit_LIBRARY		= 	-lRead_unit_to_Execution_unit	\
 							$(Behavioural_LIBRARY)	
 
-Read_unit_to_Execution_unit_DIR_LIBRARY		=	-L$(Read_unit_to_Execution_unit_DIR)/lib	\
-							$(Behavioural_DIR_LIBRARY)
-
 #-----[ Rules ]--------------------------------------------
 
-Read_unit_to_Execution_unit_library		:
+Read_unit_to_Execution_unit_library_only	:
+						@\
+						$(MAKE) --directory=$(Read_unit_to_Execution_unit_DIR) 	--makefile=Makefile;
+
+Read_unit_to_Execution_unit_library_clean_only	:
+						@\
+						$(MAKE) --directory=$(Read_unit_to_Execution_unit_DIR) 	--makefile=Makefile clean;
+
+Read_unit_to_Execution_unit_library		: Read_unit_to_Execution_unit_library_only
 						@\
 						$(MAKE) Behavioural_library;
-						$(MAKE) --directory=$(Read_unit_to_Execution_unit_DIR) 	--makefile=Makefile;
 
-Read_unit_to_Execution_unit_library_clean	:
+Read_unit_to_Execution_unit_library_clean	: Read_unit_to_Execution_unit_library_clean_only
 						@\
 						$(MAKE) Behavioural_library_clean;
-						$(MAKE) --directory=$(Read_unit_to_Execution_unit_DIR) 	--makefile=Makefile clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Makefile.deps	(revision 142)
@@ -2,5 +2,5 @@
 # $Id$
 # 
-# [ Description ]
+# [ Description ]
 # 
 # Makefile
@@ -9,5 +9,4 @@
 
 Register_unit			= yes
-
 
 ifndef RegisterFile
@@ -21,5 +20,6 @@
 endif
 
-#-----[ Library ]------------------------------------------
+#-----[ Library ]------------------------------------------
+
 Register_unit_LIBRARY		= 	-lRegister_unit				\
 					$(RegisterFile_LIBRARY)			\
@@ -27,26 +27,23 @@
 					$(Behavioural_LIBRARY)	
 
-Register_unit_DIR_LIBRARY	=	-L$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/lib	\
-					$(RegisterFile_DIR_LIBRARY)		\
-					$(Register_unit_Glue_DIR_LIBRARY)	\
-					$(Behavioural_DIR_LIBRARY)
+#-----[ Rules ]--------------------------------------------
 
-Register_unit_DEPENDENCIES	=	RegisterFile_library			\
-					Register_unit_Glue_library 		\
-					Behavioural_library
-
-Register_unit_CLEAN        	=	RegisterFile_library_clean		\
-					Register_unit_Glue_library_clean 	\
-					Behavioural_library_clean
-
-#-----[ Rules ]--------------------------------------------
-
-.NOTPARALLEL			: Register_unit_library Register_unit_library_clean	
-
-Register_unit_library		: $(Register_unit_DEPENDENCIES)
+Register_unit_library_only	:
 				@\
 				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit --makefile=Makefile;
 
-Register_unit_library_clean	: $(Register_unit_CLEAN)
+Register_unit_library_clean_only:
 				@\
 				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit --makefile=Makefile clean;
+
+Register_unit_library		: Register_unit_library_only
+				@\
+				$(MAKE) RegisterFile_library;		\
+				$(MAKE) Register_unit_Glue_library; 	\
+				$(MAKE) Behavioural_library;
+
+Register_unit_library_clean	: Register_unit_library_clean_only
+				@\
+				$(MAKE) RegisterFile_library_clean;		\
+				$(MAKE) Register_unit_Glue_library_clean; 	\
+				$(MAKE) Behavioural_library_clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/Makefile.deps	(revision 138)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/Makefile.deps	(revision 142)
@@ -11,23 +11,27 @@
 
 ifndef Behavioural
-include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+include 				$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
 
 #-----[ Library ]------------------------------------------
+
 Register_unit_Glue_LIBRARY		= 	-lRegister_unit_Glue	\
-					$(Behavioural_LIBRARY)	
-
-Register_unit_Glue_DIR_LIBRARY		=	-L$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/lib	\
-					$(Behavioural_DIR_LIBRARY)
+						$(Behavioural_LIBRARY)	
 
 #-----[ Rules ]--------------------------------------------
 
-Register_unit_Glue_library		: 
-				@\
-				$(MAKE) Behavioural_library; \
-				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue --makefile=Makefile;
+Register_unit_Glue_library_only		: 
+					@\
+					$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue --makefile=Makefile;
 	
-Register_unit_Glue_library_clean	: 
-				@\
-				$(MAKE) Behavioural_library_clean; \
-				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue --makefile=Makefile clean;
+Register_unit_Glue_library_clean_only	: 
+					@\
+					$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue --makefile=Makefile clean;
+
+Register_unit_Glue_library		: Register_unit_Glue_library_only
+					@\
+					$(MAKE) Behavioural_library;
+	
+Register_unit_Glue_library_clean	: Register_unit_Glue_library_clean_only
+					@\
+					$(MAKE) Behavioural_library_clean;